diff --git a/build-all.sh b/build-all.sh
index 5571391..9c8266f 100644
--- a/build-all.sh
+++ b/build-all.sh
@@ -56,6 +56,7 @@ build_maven_module() {
build_maven_module "spring-boot/dependency-injection"
build_maven_module "spring-boot/spring-boot-openapi"
+build_maven_module "spring-boot/data-migration/liquibase"
build_gradle_module "spring-boot/boundaries"
build_gradle_module "spring-boot/argumentresolver"
build_gradle_module "spring-data/spring-data-jdbc-converter"
diff --git a/spring-boot/data-migration/liquibase/.gitignore b/spring-boot/data-migration/liquibase/.gitignore
new file mode 100644
index 0000000..a2a3040
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/.gitignore
@@ -0,0 +1,31 @@
+HELP.md
+target/
+!.mvn/wrapper/maven-wrapper.jar
+!**/src/main/**
+!**/src/test/**
+
+### STS ###
+.apt_generated
+.classpath
+.factorypath
+.project
+.settings
+.springBeans
+.sts4-cache
+
+### IntelliJ IDEA ###
+.idea
+*.iws
+*.iml
+*.ipr
+
+### NetBeans ###
+/nbproject/private/
+/nbbuild/
+/dist/
+/nbdist/
+/.nb-gradle/
+build/
+
+### VS Code ###
+.vscode/
diff --git a/spring-boot/data-migration/liquibase/.mvn/wrapper/MavenWrapperDownloader.java b/spring-boot/data-migration/liquibase/.mvn/wrapper/MavenWrapperDownloader.java
new file mode 100644
index 0000000..e76d1f3
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/.mvn/wrapper/MavenWrapperDownloader.java
@@ -0,0 +1,117 @@
+/*
+ * Copyright 2007-present the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ * https://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+import java.net.*;
+import java.io.*;
+import java.nio.channels.*;
+import java.util.Properties;
+
+public class MavenWrapperDownloader {
+
+ private static final String WRAPPER_VERSION = "0.5.6";
+ /**
+ * Default URL to download the maven-wrapper.jar from, if no 'downloadUrl' is provided.
+ */
+ private static final String DEFAULT_DOWNLOAD_URL = "https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/"
+ + WRAPPER_VERSION + "/maven-wrapper-" + WRAPPER_VERSION + ".jar";
+
+ /**
+ * Path to the maven-wrapper.properties file, which might contain a downloadUrl property to
+ * use instead of the default one.
+ */
+ private static final String MAVEN_WRAPPER_PROPERTIES_PATH =
+ ".mvn/wrapper/maven-wrapper.properties";
+
+ /**
+ * Path where the maven-wrapper.jar will be saved to.
+ */
+ private static final String MAVEN_WRAPPER_JAR_PATH =
+ ".mvn/wrapper/maven-wrapper.jar";
+
+ /**
+ * Name of the property which should be used to override the default download url for the wrapper.
+ */
+ private static final String PROPERTY_NAME_WRAPPER_URL = "wrapperUrl";
+
+ public static void main(String args[]) {
+ System.out.println("- Downloader started");
+ File baseDirectory = new File(args[0]);
+ System.out.println("- Using base directory: " + baseDirectory.getAbsolutePath());
+
+ // If the maven-wrapper.properties exists, read it and check if it contains a custom
+ // wrapperUrl parameter.
+ File mavenWrapperPropertyFile = new File(baseDirectory, MAVEN_WRAPPER_PROPERTIES_PATH);
+ String url = DEFAULT_DOWNLOAD_URL;
+ if(mavenWrapperPropertyFile.exists()) {
+ FileInputStream mavenWrapperPropertyFileInputStream = null;
+ try {
+ mavenWrapperPropertyFileInputStream = new FileInputStream(mavenWrapperPropertyFile);
+ Properties mavenWrapperProperties = new Properties();
+ mavenWrapperProperties.load(mavenWrapperPropertyFileInputStream);
+ url = mavenWrapperProperties.getProperty(PROPERTY_NAME_WRAPPER_URL, url);
+ } catch (IOException e) {
+ System.out.println("- ERROR loading '" + MAVEN_WRAPPER_PROPERTIES_PATH + "'");
+ } finally {
+ try {
+ if(mavenWrapperPropertyFileInputStream != null) {
+ mavenWrapperPropertyFileInputStream.close();
+ }
+ } catch (IOException e) {
+ // Ignore ...
+ }
+ }
+ }
+ System.out.println("- Downloading from: " + url);
+
+ File outputFile = new File(baseDirectory.getAbsolutePath(), MAVEN_WRAPPER_JAR_PATH);
+ if(!outputFile.getParentFile().exists()) {
+ if(!outputFile.getParentFile().mkdirs()) {
+ System.out.println(
+ "- ERROR creating output directory '" + outputFile.getParentFile().getAbsolutePath() + "'");
+ }
+ }
+ System.out.println("- Downloading to: " + outputFile.getAbsolutePath());
+ try {
+ downloadFileFromURL(url, outputFile);
+ System.out.println("Done");
+ System.exit(0);
+ } catch (Throwable e) {
+ System.out.println("- Error downloading");
+ e.printStackTrace();
+ System.exit(1);
+ }
+ }
+
+ private static void downloadFileFromURL(String urlString, File destination) throws Exception {
+ if (System.getenv("MVNW_USERNAME") != null && System.getenv("MVNW_PASSWORD") != null) {
+ String username = System.getenv("MVNW_USERNAME");
+ char[] password = System.getenv("MVNW_PASSWORD").toCharArray();
+ Authenticator.setDefault(new Authenticator() {
+ @Override
+ protected PasswordAuthentication getPasswordAuthentication() {
+ return new PasswordAuthentication(username, password);
+ }
+ });
+ }
+ URL website = new URL(urlString);
+ ReadableByteChannel rbc;
+ rbc = Channels.newChannel(website.openStream());
+ FileOutputStream fos = new FileOutputStream(destination);
+ fos.getChannel().transferFrom(rbc, 0, Long.MAX_VALUE);
+ fos.close();
+ rbc.close();
+ }
+
+}
diff --git a/spring-boot/data-migration/liquibase/.mvn/wrapper/maven-wrapper.jar b/spring-boot/data-migration/liquibase/.mvn/wrapper/maven-wrapper.jar
new file mode 100644
index 0000000..2cc7d4a
Binary files /dev/null and b/spring-boot/data-migration/liquibase/.mvn/wrapper/maven-wrapper.jar differ
diff --git a/spring-boot/data-migration/liquibase/.mvn/wrapper/maven-wrapper.properties b/spring-boot/data-migration/liquibase/.mvn/wrapper/maven-wrapper.properties
new file mode 100644
index 0000000..642d572
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/.mvn/wrapper/maven-wrapper.properties
@@ -0,0 +1,2 @@
+distributionUrl=https://repo.maven.apache.org/maven2/org/apache/maven/apache-maven/3.6.3/apache-maven-3.6.3-bin.zip
+wrapperUrl=https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar
diff --git a/spring-boot/data-migration/liquibase/README.md b/spring-boot/data-migration/liquibase/README.md
new file mode 100644
index 0000000..a73e610
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/README.md
@@ -0,0 +1,122 @@
+# liquibase-demo
+
+This project demonstrates on how to set-up liquibase in a Spring Boot application.
+
+When this project is run, it executes the changelogs and creates a `user_details` table and populates it with some test data.
+It also creates an index and couple of constraints on `user_details` table.
+
+The project also demonstrates the following.
+
+* Organising liquibase change logs [using master changelog](src/main/resources/db/changelog/db.changelog-master.yaml)
+* It demonstrates how to write a [change log in YAML format](src/main/resources/db/changelog/db.changelog-yaml-example.yaml)
+* It demonstrates how to write a [change log in JSON format](src/main/resources/db/changelog/db.changelog-json-example.json)
+* It demonstrates how to write a [change log in XML format](src/main/resources/db/changelog/db.changelog-xml-example.xml)
+* It demonstrates how to write a [change log in SQL format](src/main/resources/db/changelog/db.changelog-sql-example.sql)
+* Enable `INFO` [logs for liquibase](src/main/resources/application.yaml#L10-L12).
+* It demonstrates testing of changes done by liquibase to the [schema using Junit test](src/test/java/io/reflectoring/liquibase/adapter/datastore/UserRepositoryDockerProfileTest.java)
+* It demonstrates use of liquibase [change log parameters](src/main/resources/db/changelog/db.changelog-yaml-example.yaml#L21-L33)
+* IT demonstrates use of liquibase [context](src/main/resources/db/changelog/db.changelog-xml-example.xml#L5)
+
+## How to Run the project and tests
+
+### Have Docker and Docker Compose in your machine?
+
+#### Run application
+- Clone this repository
+
+```
+ git clone https://github.com/thombergs/code-examples/spring-boot/data-migration/liquibase
+```
+- Move to the directory `code-examples/spring-boot/data-migration/liquibase`
+
+- Run the docker compose file `infra-local.yaml` in `src/docker`. This starts the postgres database needed to run the application.
+```
+ docker-compose -f ./src/main/docker/infra-local.yaml up -d
+```
+- Now run the spring boot application as follows.
+```
+ mvnw spring-boot:run -Dspring-boot.run.profiles=docker
+```
+
+The application should start and listening on port `8080`.
+
+Open the url (http://localhost:8080/liquibase/users/100000000) in the browser. You should see a response as below
+
+```json
+{
+"id": 100000000,
+"userName": "testUser",
+"firstName": "testFirstName",
+"lastName": "testLastName"
+}
+```
+
+You can login to the database and check the creation of `user_details` table along with some test data in it.
+```yaml
+ #Use below credentials to login to the database
+ databaseHost: localhost
+ jdbcUrl: jdbc:postgresql://localhost:5432/liquibasedemo?current_schema=public
+ port: 5432
+ username: demouser
+ password: demopassword
+```
+
+Also, have a look at databasechangelog and databasechangeloglock tables.
+
+#### Run Test
+To run integration test, you don't need to run the docker compose file. Just run the test as follows:
+
+```yaml
+mvn test -Dspring.profiles.active=docker
+
+```
+The test uses [TestContainers](https://www.testcontainers.org/) to spin a postgres database, which is used during the integration test.
+
+### Don't have docker?
+
+You can use h2 profile to run the app and use h2 database.
+
+- Clone this repository
+
+```
+ git clone https://github.com/thombergs/code-examples/spring-boot/data-migration/liquibase
+```
+- Move to the directory `code-examples/spring-boot/data-migration/liquibase`
+
+- Now run the spring boot application as follows.
+```
+ mvnw spring-boot:run -Dspring-boot.run.profiles=h2
+```
+
+The application should start and listening on port `8080`.
+
+Open the url (http://localhost:8080/liquibase/users/100000000) in the browser. You should see a response as below
+
+```json
+{
+"id": 100000000,
+"userName": "testUser",
+"firstName": "testFirstName",
+"lastName": "testLastName"
+}
+```
+
+Login to h2 database console using [url](http://localhost:8080/liquibase/h2-console)
+
+```yaml
+ JDBC URL: jdbc:h2:mem:liquibasedemo
+ username: demouser
+ password: demopassword
+```
+Check the creation of `user_details` table along with some test data in it.
+
+Also, have a look at databasechangelog and databasechangeloglock tables.
+
+#### Run Test
+To run integration test
+
+```yaml
+mvn test -Dspring.profiles.active=h2
+
+```
+
diff --git a/spring-boot/data-migration/liquibase/mvnw b/spring-boot/data-migration/liquibase/mvnw
new file mode 100644
index 0000000..a16b543
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/mvnw
@@ -0,0 +1,310 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+# JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+# M2_HOME - location of maven2's installed home dir
+# MAVEN_OPTS - parameters passed to the Java VM when running Maven
+# e.g. to debug Maven itself, use
+# set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+# MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ] ; then
+
+ if [ -f /etc/mavenrc ] ; then
+ . /etc/mavenrc
+ fi
+
+ if [ -f "$HOME/.mavenrc" ] ; then
+ . "$HOME/.mavenrc"
+ fi
+
+fi
+
+# OS specific support. $var _must_ be set to either true or false.
+cygwin=false;
+darwin=false;
+mingw=false
+case "`uname`" in
+ CYGWIN*) cygwin=true ;;
+ MINGW*) mingw=true;;
+ Darwin*) darwin=true
+ # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
+ # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
+ if [ -z "$JAVA_HOME" ]; then
+ if [ -x "/usr/libexec/java_home" ]; then
+ export JAVA_HOME="`/usr/libexec/java_home`"
+ else
+ export JAVA_HOME="/Library/Java/Home"
+ fi
+ fi
+ ;;
+esac
+
+if [ -z "$JAVA_HOME" ] ; then
+ if [ -r /etc/gentoo-release ] ; then
+ JAVA_HOME=`java-config --jre-home`
+ fi
+fi
+
+if [ -z "$M2_HOME" ] ; then
+ ## resolve links - $0 may be a link to maven's home
+ PRG="$0"
+
+ # need this for relative symlinks
+ while [ -h "$PRG" ] ; do
+ ls=`ls -ld "$PRG"`
+ link=`expr "$ls" : '.*-> \(.*\)$'`
+ if expr "$link" : '/.*' > /dev/null; then
+ PRG="$link"
+ else
+ PRG="`dirname "$PRG"`/$link"
+ fi
+ done
+
+ saveddir=`pwd`
+
+ M2_HOME=`dirname "$PRG"`/..
+
+ # make it fully qualified
+ M2_HOME=`cd "$M2_HOME" && pwd`
+
+ cd "$saveddir"
+ # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --unix "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
+fi
+
+# For Mingw, ensure paths are in UNIX format before anything is touched
+if $mingw ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME="`(cd "$M2_HOME"; pwd)`"
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ javaExecutable="`which javac`"
+ if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
+ # readlink(1) is not available as standard on Solaris 10.
+ readLink=`which readlink`
+ if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
+ if $darwin ; then
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
+ else
+ javaExecutable="`readlink -f \"$javaExecutable\"`"
+ fi
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaHome=`expr "$javaHome" : '\(.*\)/bin'`
+ JAVA_HOME="$javaHome"
+ export JAVA_HOME
+ fi
+ fi
+fi
+
+if [ -z "$JAVACMD" ] ; then
+ if [ -n "$JAVA_HOME" ] ; then
+ if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
+ # IBM's JDK on AIX uses strange locations for the executables
+ JAVACMD="$JAVA_HOME/jre/sh/java"
+ else
+ JAVACMD="$JAVA_HOME/bin/java"
+ fi
+ else
+ JAVACMD="`which java`"
+ fi
+fi
+
+if [ ! -x "$JAVACMD" ] ; then
+ echo "Error: JAVA_HOME is not defined correctly." >&2
+ echo " We cannot execute $JAVACMD" >&2
+ exit 1
+fi
+
+if [ -z "$JAVA_HOME" ] ; then
+ echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+
+ if [ -z "$1" ]
+ then
+ echo "Path not specified to find_maven_basedir"
+ return 1
+ fi
+
+ basedir="$1"
+ wdir="$1"
+ while [ "$wdir" != '/' ] ; do
+ if [ -d "$wdir"/.mvn ] ; then
+ basedir=$wdir
+ break
+ fi
+ # workaround for JBEAP-8937 (on Solaris 10/Sparc)
+ if [ -d "${wdir}" ]; then
+ wdir=`cd "$wdir/.."; pwd`
+ fi
+ # end of workaround
+ done
+ echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+ if [ -f "$1" ]; then
+ echo "$(tr -s '\n' ' ' < "$1")"
+ fi
+}
+
+BASE_DIR=`find_maven_basedir "$(pwd)"`
+if [ -z "$BASE_DIR" ]; then
+ exit 1;
+fi
+
+##########################################################################################
+# Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+# This allows using the maven wrapper in projects that prohibit checking in binary data.
+##########################################################################################
+if [ -r "$BASE_DIR/.mvn/wrapper/maven-wrapper.jar" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found .mvn/wrapper/maven-wrapper.jar"
+ fi
+else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Couldn't find .mvn/wrapper/maven-wrapper.jar, downloading it ..."
+ fi
+ if [ -n "$MVNW_REPOURL" ]; then
+ jarUrl="$MVNW_REPOURL/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar"
+ else
+ jarUrl="https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar"
+ fi
+ while IFS="=" read key value; do
+ case "$key" in (wrapperUrl) jarUrl="$value"; break ;;
+ esac
+ done < "$BASE_DIR/.mvn/wrapper/maven-wrapper.properties"
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Downloading from: $jarUrl"
+ fi
+ wrapperJarPath="$BASE_DIR/.mvn/wrapper/maven-wrapper.jar"
+ if $cygwin; then
+ wrapperJarPath=`cygpath --path --windows "$wrapperJarPath"`
+ fi
+
+ if command -v wget > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found wget ... using wget"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ wget "$jarUrl" -O "$wrapperJarPath"
+ else
+ wget --http-user=$MVNW_USERNAME --http-password=$MVNW_PASSWORD "$jarUrl" -O "$wrapperJarPath"
+ fi
+ elif command -v curl > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found curl ... using curl"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ curl -o "$wrapperJarPath" "$jarUrl" -f
+ else
+ curl --user $MVNW_USERNAME:$MVNW_PASSWORD -o "$wrapperJarPath" "$jarUrl" -f
+ fi
+
+ else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Falling back to using Java to download"
+ fi
+ javaClass="$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.java"
+ # For Cygwin, switch paths to Windows format before running javac
+ if $cygwin; then
+ javaClass=`cygpath --path --windows "$javaClass"`
+ fi
+ if [ -e "$javaClass" ]; then
+ if [ ! -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Compiling MavenWrapperDownloader.java ..."
+ fi
+ # Compiling the Java class
+ ("$JAVA_HOME/bin/javac" "$javaClass")
+ fi
+ if [ -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ # Running the downloader
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Running MavenWrapperDownloader.java ..."
+ fi
+ ("$JAVA_HOME/bin/java" -cp .mvn/wrapper MavenWrapperDownloader "$MAVEN_PROJECTBASEDIR")
+ fi
+ fi
+ fi
+fi
+##########################################################################################
+# End of extension
+##########################################################################################
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
+if [ "$MVNW_VERBOSE" = true ]; then
+ echo $MAVEN_PROJECTBASEDIR
+fi
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --path --windows "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
+ [ -n "$MAVEN_PROJECTBASEDIR" ] &&
+ MAVEN_PROJECTBASEDIR=`cygpath --path --windows "$MAVEN_PROJECTBASEDIR"`
+fi
+
+# Provide a "standardized" way to retrieve the CLI args that will
+# work with both Windows and non-Windows executions.
+MAVEN_CMD_LINE_ARGS="$MAVEN_CONFIG $@"
+export MAVEN_CMD_LINE_ARGS
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+ $MAVEN_OPTS \
+ -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+ "-Dmaven.home=${M2_HOME}" "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+ ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"
diff --git a/spring-boot/data-migration/liquibase/mvnw.cmd b/spring-boot/data-migration/liquibase/mvnw.cmd
new file mode 100644
index 0000000..c8d4337
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/mvnw.cmd
@@ -0,0 +1,182 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements. See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership. The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License. You may obtain a copy of the License at
+@REM
+@REM https://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied. See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a keystroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM set title of command window
+title %0
+@REM enable echoing by setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on" echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_pre.bat" call "%HOME%\mavenrc_pre.bat"
+if exist "%HOME%\mavenrc_pre.cmd" call "%HOME%\mavenrc_pre.cmd"
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+set DOWNLOAD_URL="https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar"
+
+FOR /F "tokens=1,2 delims==" %%A IN ("%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.properties") DO (
+ IF "%%A"=="wrapperUrl" SET DOWNLOAD_URL=%%B
+)
+
+@REM Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+@REM This allows using the maven wrapper in projects that prohibit checking in binary data.
+if exist %WRAPPER_JAR% (
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Found %WRAPPER_JAR%
+ )
+) else (
+ if not "%MVNW_REPOURL%" == "" (
+ SET DOWNLOAD_URL="%MVNW_REPOURL%/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar"
+ )
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Couldn't find %WRAPPER_JAR%, downloading it ...
+ echo Downloading from: %DOWNLOAD_URL%
+ )
+
+ powershell -Command "&{"^
+ "$webclient = new-object System.Net.WebClient;"^
+ "if (-not ([string]::IsNullOrEmpty('%MVNW_USERNAME%') -and [string]::IsNullOrEmpty('%MVNW_PASSWORD%'))) {"^
+ "$webclient.Credentials = new-object System.Net.NetworkCredential('%MVNW_USERNAME%', '%MVNW_PASSWORD%');"^
+ "}"^
+ "[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12; $webclient.DownloadFile('%DOWNLOAD_URL%', '%WRAPPER_JAR%')"^
+ "}"
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Finished downloading %WRAPPER_JAR%
+ )
+)
+@REM End of extension
+
+@REM Provide a "standardized" way to retrieve the CLI args that will
+@REM work with both Windows and non-Windows executions.
+set MAVEN_CMD_LINE_ARGS=%*
+
+%MAVEN_JAVA_EXE% %JVM_CONFIG_MAVEN_PROPS% %MAVEN_OPTS% %MAVEN_DEBUG_OPTS% -classpath %WRAPPER_JAR% "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_post.bat" call "%HOME%\mavenrc_post.bat"
+if exist "%HOME%\mavenrc_post.cmd" call "%HOME%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%" == "on" pause
+
+if "%MAVEN_TERMINATE_CMD%" == "on" exit %ERROR_CODE%
+
+exit /B %ERROR_CODE%
diff --git a/spring-boot/data-migration/liquibase/pom.xml b/spring-boot/data-migration/liquibase/pom.xml
new file mode 100644
index 0000000..05b5fc5
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/pom.xml
@@ -0,0 +1,130 @@
+
+
+ 4.0.0
+
+ org.springframework.boot
+ spring-boot-starter-parent
+ 2.2.6.RELEASE
+
+
+ io.reflectoring
+ liquibase
+ 0.0.1-SNAPSHOT
+ liquibase
+ Code example for Spring Boot liquibase
+
+
+ 11
+
+
+
+
+ org.springframework.boot
+ spring-boot-starter-data-jpa
+
+
+ org.springframework.boot
+ spring-boot-starter-validation
+
+
+ org.springframework.boot
+ spring-boot-starter-logging
+
+
+
+
+ org.springframework.boot
+ spring-boot-starter-web
+
+
+ org.springframework.boot
+ spring-boot-starter-logging
+
+
+
+
+ org.springframework.boot
+ spring-boot-starter-log4j2
+
+
+ com.fasterxml.jackson.dataformat
+ jackson-dataformat-yaml
+
+
+ org.liquibase
+ liquibase-core
+
+
+ com.h2database
+ h2
+ runtime
+
+
+ org.springframework.boot
+ spring-boot-devtools
+ runtime
+ true
+
+
+ org.postgresql
+ postgresql
+ runtime
+
+
+ org.springframework.boot
+ spring-boot-configuration-processor
+ true
+
+
+ org.projectlombok
+ lombok
+ true
+
+
+ org.springframework.boot
+ spring-boot-starter-test
+ test
+
+
+ org.junit.vintage
+ junit-vintage-engine
+
+
+
+
+ org.assertj
+ assertj-core
+ 3.15.0
+ test
+
+
+ org.testcontainers
+ postgresql
+ 1.13.0
+ test
+
+
+ org.testcontainers
+ testcontainers
+ 1.13.0
+ test
+
+
+ org.testcontainers
+ junit-jupiter
+ 1.13.0
+ test
+
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-maven-plugin
+
+
+
+
+
diff --git a/spring-boot/data-migration/liquibase/src/main/docker/infra-local.yaml b/spring-boot/data-migration/liquibase/src/main/docker/infra-local.yaml
new file mode 100644
index 0000000..d218249
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/src/main/docker/infra-local.yaml
@@ -0,0 +1,12 @@
+version: "3.0"
+services:
+ database:
+ image: library/postgres:latest
+ ports:
+ - 5432:5432
+ expose:
+ - 5432
+ environment:
+ - POSTGRES_PASSWORD=demopassword
+ - POSTGRES_USER=demouser
+ - POSTGRES_DB=liquibasedemo
diff --git a/spring-boot/data-migration/liquibase/src/main/java/io/reflectoring/liquibase/LiquibaseApplication.java b/spring-boot/data-migration/liquibase/src/main/java/io/reflectoring/liquibase/LiquibaseApplication.java
new file mode 100644
index 0000000..f9ef85f
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/src/main/java/io/reflectoring/liquibase/LiquibaseApplication.java
@@ -0,0 +1,13 @@
+package io.reflectoring.liquibase;
+
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.SpringBootApplication;
+
+@SpringBootApplication
+public class LiquibaseApplication {
+
+ public static void main(String[] args) {
+ SpringApplication.run(LiquibaseApplication.class, args);
+ }
+
+}
diff --git a/spring-boot/data-migration/liquibase/src/main/java/io/reflectoring/liquibase/adapter/api/UserController.java b/spring-boot/data-migration/liquibase/src/main/java/io/reflectoring/liquibase/adapter/api/UserController.java
new file mode 100644
index 0000000..dc7d698
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/src/main/java/io/reflectoring/liquibase/adapter/api/UserController.java
@@ -0,0 +1,33 @@
+package io.reflectoring.liquibase.adapter.api;
+
+import io.reflectoring.liquibase.adapter.datastore.UserRepository;
+import io.reflectoring.liquibase.domain.User;
+import org.springframework.http.ResponseEntity;
+import org.springframework.web.bind.annotation.GetMapping;
+import org.springframework.web.bind.annotation.PathVariable;
+import org.springframework.web.bind.annotation.PostMapping;
+import org.springframework.web.bind.annotation.RequestBody;
+import org.springframework.web.bind.annotation.RequestMapping;
+import org.springframework.web.bind.annotation.RestController;
+
+@RestController
+@RequestMapping("/users")
+public class UserController {
+
+ private final UserRepository userRepository;
+
+ public UserController(UserRepository userRepository) {
+ this.userRepository = userRepository;
+ }
+
+ @PostMapping
+ public User addUser(@RequestBody User user) {
+ return userRepository.save(user);
+ }
+
+ @GetMapping("/{id}")
+ public ResponseEntity getUser(@PathVariable("id") Long userId) {
+ return ResponseEntity.of(userRepository.findById(userId));
+ }
+
+}
diff --git a/spring-boot/data-migration/liquibase/src/main/java/io/reflectoring/liquibase/adapter/datastore/UserRepository.java b/spring-boot/data-migration/liquibase/src/main/java/io/reflectoring/liquibase/adapter/datastore/UserRepository.java
new file mode 100644
index 0000000..cb2fb46
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/src/main/java/io/reflectoring/liquibase/adapter/datastore/UserRepository.java
@@ -0,0 +1,7 @@
+package io.reflectoring.liquibase.adapter.datastore;
+
+import io.reflectoring.liquibase.domain.User;
+import org.springframework.data.jpa.repository.JpaRepository;
+
+public interface UserRepository extends JpaRepository {
+}
diff --git a/spring-boot/data-migration/liquibase/src/main/java/io/reflectoring/liquibase/domain/User.java b/spring-boot/data-migration/liquibase/src/main/java/io/reflectoring/liquibase/domain/User.java
new file mode 100644
index 0000000..fbe9c97
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/src/main/java/io/reflectoring/liquibase/domain/User.java
@@ -0,0 +1,59 @@
+package io.reflectoring.liquibase.domain;
+
+import javax.persistence.Column;
+import javax.persistence.Entity;
+import javax.persistence.GeneratedValue;
+import javax.persistence.GenerationType;
+import javax.persistence.Id;
+import javax.persistence.Table;
+
+@Entity
+@Table(name = "user_details")
+public class User {
+
+ @Id
+ @Column(name ="id")
+ @GeneratedValue(strategy = GenerationType.IDENTITY)
+ private Long id;
+
+ @Column(name = "username")
+ private String userName;
+
+ @Column(name = "first_name")
+ private String firstName;
+
+ @Column(name = "last_name")
+ private String lastName;
+
+ public Long getId() {
+ return id;
+ }
+
+ public void setId(Long id) {
+ this.id = id;
+ }
+
+ public String getUserName() {
+ return userName;
+ }
+
+ public void setUserName(String userName) {
+ this.userName = userName;
+ }
+
+ public String getFirstName() {
+ return firstName;
+ }
+
+ public void setFirstName(String firstName) {
+ this.firstName = firstName;
+ }
+
+ public String getLastName() {
+ return lastName;
+ }
+
+ public void setLastName(String lastName) {
+ this.lastName = lastName;
+ }
+}
diff --git a/spring-boot/data-migration/liquibase/src/main/resources/application.yaml b/spring-boot/data-migration/liquibase/src/main/resources/application.yaml
new file mode 100644
index 0000000..97321d1
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/src/main/resources/application.yaml
@@ -0,0 +1,43 @@
+spring:
+ profiles:
+ active: h2
+ application:
+ name: liquibase
+server:
+ servlet:
+ context-path: /liquibase
+
+logging:
+ level:
+ "liquibase" : info
+---
+spring:
+ profiles: docker
+ jpa:
+ database-platform: org.hibernate.dialect.PostgreSQLDialect
+ datasource:
+ url: jdbc:postgresql://localhost:5432/liquibasedemo?current_schema=public
+ driverClassName: org.postgresql.Driver
+ username: demouser
+ password: demopassword
+ liquibase:
+ parameters:
+ textColumnType: TEXT
+ contexts: nonprod
+---
+spring:
+ profiles: h2
+ jpa:
+ database-platform: org.hibernate.dialect.H2Dialect
+ datasource:
+ url: jdbc:h2:mem:liquibasedemo
+ driverClassName: org.h2.Driver
+ username: demouser
+ password: demopassword
+ liquibase:
+ parameters:
+ textColumnType: VARCHAR(250)
+ contexts: nonprod
+ h2:
+ console:
+ enabled: true
\ No newline at end of file
diff --git a/spring-boot/data-migration/liquibase/src/main/resources/db/changelog/db.changelog-json-example.json b/spring-boot/data-migration/liquibase/src/main/resources/db/changelog/db.changelog-json-example.json
new file mode 100644
index 0000000..3b73cb2
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/src/main/resources/db/changelog/db.changelog-json-example.json
@@ -0,0 +1,16 @@
+{ "databaseChangeLog": [
+ {
+ "changeSet": {
+ "id": "add-last-name-constraint",
+ "author": "liquibase-demo-service",
+ "changes": [
+ {
+ "addNotNullConstraint": {
+ "columnName": "last_name",
+ "constraintName": "user_last_name_key",
+ "tableName": "user_details"
+ }
+ }]
+ }
+ }
+]}
\ No newline at end of file
diff --git a/spring-boot/data-migration/liquibase/src/main/resources/db/changelog/db.changelog-master.yaml b/spring-boot/data-migration/liquibase/src/main/resources/db/changelog/db.changelog-master.yaml
new file mode 100644
index 0000000..88d0b65
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/src/main/resources/db/changelog/db.changelog-master.yaml
@@ -0,0 +1,9 @@
+databaseChangeLog:
+ - include:
+ file: db/changelog/db.changelog-yaml-example.yaml
+ - include:
+ file: db/changelog/db.changelog-sql-example.sql
+ - include:
+ file: db/changelog/db.changelog-json-example.json
+ - include:
+ file: db/changelog/db.changelog-xml-example.xml
\ No newline at end of file
diff --git a/spring-boot/data-migration/liquibase/src/main/resources/db/changelog/db.changelog-sql-example.sql b/spring-boot/data-migration/liquibase/src/main/resources/db/changelog/db.changelog-sql-example.sql
new file mode 100644
index 0000000..ac491af
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/src/main/resources/db/changelog/db.changelog-sql-example.sql
@@ -0,0 +1,4 @@
+--liquibase formatted sql
+
+--changeset liquibase-demo-service:add-user-name-constraint
+ALTER TABLE user_details ADD CONSTRAINT user_details_username_key UNIQUE (username);
diff --git a/spring-boot/data-migration/liquibase/src/main/resources/db/changelog/db.changelog-xml-example.xml b/spring-boot/data-migration/liquibase/src/main/resources/db/changelog/db.changelog-xml-example.xml
new file mode 100644
index 0000000..31a7665
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/src/main/resources/db/changelog/db.changelog-xml-example.xml
@@ -0,0 +1,16 @@
+
+
+
+
+
+
+
\ No newline at end of file
diff --git a/spring-boot/data-migration/liquibase/src/main/resources/db/changelog/db.changelog-yaml-example.yaml b/spring-boot/data-migration/liquibase/src/main/resources/db/changelog/db.changelog-yaml-example.yaml
new file mode 100644
index 0000000..5849eae
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/src/main/resources/db/changelog/db.changelog-yaml-example.yaml
@@ -0,0 +1,34 @@
+databaseChangeLog:
+ - changeSet:
+ id: create-table-user
+ author: liquibase-demo-service
+ preConditions:
+ - onFail: MARK_RAN
+ not:
+ tableExists:
+ tableName: user_details
+ changes:
+ - createTable:
+ columns:
+ - column:
+ autoIncrement: true
+ constraints:
+ nullable: false
+ primaryKey: true
+ primaryKeyName: user_pkey
+ name: id
+ type: BIGINT
+ - column:
+ constraints:
+ nullable: false
+ name: username
+ type: ${textColumnType}
+ - column:
+ constraints:
+ nullable: false
+ name: first_name
+ type: ${textColumnType}
+ - column:
+ name: last_name
+ type: ${textColumnType}
+ tableName: user_details
\ No newline at end of file
diff --git a/spring-boot/data-migration/liquibase/src/main/resources/db/data/users.csv b/spring-boot/data-migration/liquibase/src/main/resources/db/data/users.csv
new file mode 100644
index 0000000..b4bd9d2
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/src/main/resources/db/data/users.csv
@@ -0,0 +1,3 @@
+id,username,first_name,last_name
+100000000,testUser,testFirstName,testLastName
+100000001,testUser1,testFirstName1,testLastName1
diff --git a/spring-boot/data-migration/liquibase/src/main/resources/log4j2.yaml b/spring-boot/data-migration/liquibase/src/main/resources/log4j2.yaml
new file mode 100644
index 0000000..f28a2c8
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/src/main/resources/log4j2.yaml
@@ -0,0 +1,19 @@
+Configuration:
+ status: error
+
+ appenders:
+ Console:
+ name: Console
+ PatternLayout:
+ Pattern: "[%-5level] %d{yyyy-MM-dd HH:mm:ss.SSS} [%t] %c{1} - %msg%n"
+ Loggers:
+ logger:
+ - name: io.reflectoring
+ level: debug
+ additivity: false
+ AppenderRef:
+ - ref: Console
+ Root:
+ level: error
+ AppenderRef:
+ ref: Console
\ No newline at end of file
diff --git a/spring-boot/data-migration/liquibase/src/test/java/io/reflectoring/liquibase/adapter/datastore/UserRepositoryIntegrationTest.java b/spring-boot/data-migration/liquibase/src/test/java/io/reflectoring/liquibase/adapter/datastore/UserRepositoryIntegrationTest.java
new file mode 100644
index 0000000..da90ed3
--- /dev/null
+++ b/spring-boot/data-migration/liquibase/src/test/java/io/reflectoring/liquibase/adapter/datastore/UserRepositoryIntegrationTest.java
@@ -0,0 +1,67 @@
+package io.reflectoring.liquibase.adapter.datastore;
+
+import static org.assertj.core.api.Assertions.assertThat;
+
+import io.reflectoring.liquibase.domain.User;
+import java.util.Optional;
+import javax.validation.constraints.NotNull;
+import org.junit.ClassRule;
+import org.junit.jupiter.api.Test;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.boot.test.autoconfigure.jdbc.AutoConfigureTestDatabase;
+import org.springframework.boot.test.autoconfigure.orm.jpa.DataJpaTest;
+import org.springframework.context.ApplicationContextInitializer;
+import org.springframework.context.ConfigurableApplicationContext;
+import org.springframework.core.env.Profiles;
+import org.springframework.test.context.ContextConfiguration;
+import org.testcontainers.containers.PostgreSQLContainer;
+
+@DataJpaTest
+@AutoConfigureTestDatabase(replace = AutoConfigureTestDatabase.Replace.NONE)
+@ContextConfiguration(initializers = UserRepositoryIntegrationTest.Initializer.class)
+class UserRepositoryIntegrationTest {
+
+ @ClassRule
+ public static PostgreSQLContainer postgreSQLContainer = new PostgreSQLContainer()
+ .withDatabaseName("liquibasedemo").withPassword("demopassword").withUsername("demouser");
+
+ @Autowired
+ private UserRepository userRepository;
+
+
+ @Test
+ public void findById_userId100000000_returnsUserDetails() {
+ Optional user = userRepository.findById(100000000L);
+ assertThat(user.isPresent()).isTrue();
+ assertThat(user.get()).hasFieldOrPropertyWithValue("id", 100000000L)
+ .hasFieldOrPropertyWithValue("userName", "testUser");
+ }
+
+ @Test
+ public void findById_userId100000001_returnsUserDetails() {
+ Optional user = userRepository.findById(100000001L);
+ assertThat(user.isPresent()).isTrue();
+ assertThat(user.get()).hasFieldOrPropertyWithValue("id", 100000001L)
+ .hasFieldOrPropertyWithValue("userName", "testUser1");
+ }
+
+ /**
+ * This used to override the database properties in spring environment
+ */
+ public static class Initializer implements
+ ApplicationContextInitializer {
+
+ @Override
+ public void initialize(@NotNull ConfigurableApplicationContext configurableApplicationContext) {
+ if (configurableApplicationContext.getEnvironment().acceptsProfiles(Profiles.of("docker"))) {
+ postgreSQLContainer.start();
+ configurableApplicationContext.getEnvironment().getSystemProperties()
+ .put("spring.datasource.url", postgreSQLContainer.getJdbcUrl());
+ configurableApplicationContext.getEnvironment().getSystemProperties()
+ .put("spring.datasource.username", postgreSQLContainer.getUsername());
+ configurableApplicationContext.getEnvironment().getSystemProperties()
+ .put("spring.datasource.password", postgreSQLContainer.getPassword());
+ }
+ }
+ }
+}
\ No newline at end of file